require_relative '../config/multi_xml.rb'

require 'yardi/error/base'
require 'yardi/error/connection_error'
require 'yardi/error/empty_response'
require 'yardi/error/error_response'
require 'yardi/error/fault_response'
require 'yardi/error/guests_not_found'
require 'yardi/error/invalid_configuration'
require 'yardi/error/missing_property'
require 'yardi/error/no_results'
require 'yardi/error/resource_not_found'
require 'yardi/error/service_unavailable'
require 'yardi/error/unparsable_response'

require 'yardi/model/event'
require 'yardi/model/guest_card_response'
require 'yardi/model/resident'

require 'yardi/parameter/agent'
require 'yardi/parameter/contact_info'
require 'yardi/parameter/credential'
require 'yardi/parameter/property'
require 'yardi/parameter/prospect'
require 'yardi/parameter/user'

require 'yardi/request/import_yardi_guest'
require 'yardi/request/get_yardi_guest_activity'
require 'yardi/request/get_residents'

require 'yardi/version'
# The toplevel Yardi module. This includes configuration information that
# we'll need to build requests. This information is the same for all of our
# clients. Client-specific configuration is specified in credential.rb.
module Yardi
  CONFIG_KEYS = %i[
    entity
    license_key
    platform
  ].freeze

  Config = Struct.new(*CONFIG_KEYS)
  private_constant :Config

  class << self
    def configure(&block)
      yield config
    end

    def config
      @config ||= Config.new
    end
  end
end
