require 'yardi/document_parser/residents'
require 'yardi/request_section/residents'

require_relative 'base'

module Yardi
  module Request
    # Get all residents for a given property ID.
    class GetResidents < Base
      private

      attr_reader :property_id

      def after_initialize(params)
        @property_id = params[:property_id]
        raise ArgumentError, ':property_id is required' unless property_id
      end

      def parser
        DocumentParser::Residents.new(property_id)
      end

      def soap_body_sections
        [
          RequestSection::Authentication.new(credential),
          RequestSection::Residents.new(property_id: property_id)
        ]
      end

      def soap_action
        'GetResidents'
      end

      def interface
        'ItfResidentData'
      end
    end
  end
end
