module Yardi
  # ALL REQUEST SECTIONS* must define a #generate method which builds their
  # corresponding XML
  # #generate returns a Nokogiri::DocumentFragment.
  # Example:
  # class TestSectionFoo
  #   def generate
  #     foo_fragment = Nokogiri::XML::DocumentFragment.parse('')
  #
  #     Nokogiri::XML::Builder.with(foo_fragment) do |foo_xml|
  #       foo_xml.Foo 'foo_value'
  #     end
  #
  #     foo_fragment
  #   end
  # end
  #
  # * the auth section has a different signature for #generate because it is
  # the only section that is namespaced.
  module RequestSection
  end

  private_constant :RequestSection
end
