require 'yardi/request_section'

module Yardi
  module RequestSection
    # Generate the auth section of a Yardi request
    class Authentication
      attr_reader :credential

      def initialize(credential)
        @credential = credential
      end

      def generate(xml_builder)
        xml_builder['itf'].UserName credential.username
        xml_builder['itf'].Password credential.password
        xml_builder['itf'].ServerName credential.server
        xml_builder['itf'].Database credential.database
        xml_builder['itf'].Platform Yardi.config.platform
        xml_builder['itf'].InterfaceEntity Yardi.config.entity
        xml_builder['itf'].InterfaceLicense Yardi.config.license_key
      end
    end
  end
end
