require 'yardi/request_section'

module Yardi
  module RequestSection
    # Generate the data needed for a ProspectSearch
    class Prospect
      attr_reader :property_id, :prospect

      def initialize(property_id:, prospect:)
        @property_id = property_id
        @prospect = prospect
      end

      # Even though we may not send data for some fields, Yardi needs empty
      # nodes or the request fails.
      def generate(xml_builder)
        xml_builder['itf'].YardiPropertyId property_id
        xml_builder['itf'].FirstName prospect.first_name
        xml_builder['itf'].LastName prospect.last_name
        xml_builder['itf'].EmailAddress prospect.email
        xml_builder['itf'].PhoneNumber prospect.phone
        xml_builder['itf'].ThirdPartyId prospect.yardi_prospect_id
        xml_builder['itf'].FederalId
      end
    end
  end
end
