require 'yardi/utils'

module Yardi
  module Utils
    class ConfigurationValidator
      def validate!
        missing_keys = Yardi::CONFIG_KEYS.select do |key|
          Yardi.config.send(key).nil?
        end
        unless missing_keys.empty?
          raise Error::InvalidConfiguration,
                "Missing configuration for #{missing_keys.join(', ')}"
        end
      end
    end
  end
end
