require 'yardi/utils'

module Yardi
  module Utils
    class PhoneParser
      # A single prospect/resident can have have 0 to many <Phone> nodes, so
      # prospect/resident['Phone'] can have three different types:
      #   nil if there's no phone included
      #   a Hash representing a single phone number if there's one phone
      #   an Array if there are multiple phones
      # @param phone [nil|Hash|Array]
      # @return [Array<String>] if at least one `PhoneNumber` exists, or nil
      #   otherwise.
      def self.parse(phone)
        if phone.is_a?(Array)
          phone.map { |ph| ph['PhoneNumber'] }.compact
        elsif phone && phone['PhoneNumber']
          [phone['PhoneNumber']]
        end
      end
    end
  end
end
